# Change Log

All notable changes to this project will be documented in this file. See [standard-version](https://github.com/conventional-changelog/standard-version) for commit guidelines.

<a name="2.0.0"></a>
# [2.0.0](https://github.com/medfreeman/nuxt-netlify-cms-module/compare/v1.2.1...v2.0.0) (2017-09-21)


### Bug Fixes

* **package:** eslint compliance on commonjs index ([55a8f07](https://github.com/medfreeman/nuxt-netlify-cms-module/commit/55a8f07))


### Chores

* **package:** re-export module in commonjs format ([1bba36c](https://github.com/medfreeman/nuxt-netlify-cms-module/commit/1bba36c)), closes [#19](https://github.com/medfreeman/nuxt-netlify-cms-module/issues/19)


### Features

* **config:** enforce a single `netlify-cms` folder ([3fcbc2c](https://github.com/medfreeman/nuxt-netlify-cms-module/commit/3fcbc2c)), closes [#21](https://github.com/medfreeman/nuxt-netlify-cms-module/issues/21)


### BREAKING CHANGES

* **config:** the cms config file should be placed in the "netlify-cms" folder and named "config.yml" along with the extensions js files
* **config:** remove `extensionsDir` option
* **package:** remove having to use `.default` while requiring this module



<a name="1.2.1"></a>
## [1.2.1](https://github.com/medfreeman/nuxt-netlify-cms-module/compare/v1.2.0...v1.2.1) (2017-09-18)


### Bug Fixes

* **cms-config:** properly prepend `file` paths with nuxt `srcDir` ([c189b0f](https://github.com/medfreeman/nuxt-netlify-cms-module/commit/c189b0f)), closes [#18](https://github.com/medfreeman/nuxt-netlify-cms-module/issues/18)



<a name="1.2.0"></a>
# [1.2.0](https://github.com/medfreeman/nuxt-netlify-cms-module/compare/v1.1.0...v1.2.0) (2017-09-09)


### Bug Fixes

* **build:** fix various rebuild errors ([229a257](https://github.com/medfreeman/nuxt-netlify-cms-module/commit/229a257)), closes [#7](https://github.com/medfreeman/nuxt-netlify-cms-module/issues/7) [#9](https://github.com/medfreeman/nuxt-netlify-cms-module/issues/9) [#10](https://github.com/medfreeman/nuxt-netlify-cms-module/issues/10)
* **package:** remove duplicate `lodash.omit` dependency ([d5e1017](https://github.com/medfreeman/nuxt-netlify-cms-module/commit/d5e1017))


### Features

* **build:** add a notification of bundle rebuilding and completion ([6c51d10](https://github.com/medfreeman/nuxt-netlify-cms-module/commit/6c51d10)), closes [#11](https://github.com/medfreeman/nuxt-netlify-cms-module/issues/11)
* **build:** add webpack hot reloading ([05748d7](https://github.com/medfreeman/nuxt-netlify-cms-module/commit/05748d7)), closes [#15](https://github.com/medfreeman/nuxt-netlify-cms-module/issues/15)
* **build:** show pretty build status ([c4107f2](https://github.com/medfreeman/nuxt-netlify-cms-module/commit/c4107f2))



<a name="1.1.0"></a>
# [1.1.0](https://github.com/medfreeman/nuxt-netlify-cms-module/compare/v1.0.0...v1.1.0) (2017-09-08)


### Bug Fixes

* **core:** avoid calling file existsSync before reading ([312c14b](https://github.com/medfreeman/nuxt-netlify-cms-module/commit/312c14b))


### Features

* **core:** add support for netlify-cms extensions ([f670cf3](https://github.com/medfreeman/nuxt-netlify-cms-module/commit/f670cf3))



<a name="1.0.0"></a>
# [1.0.0](https://github.com/medfreeman/nuxt-netlify-cms-module/compare/v0.1.4...v1.0.0) (2017-09-04)


### Features

* **package:** allow end-user to specify `netlify-cms` version ([78bda84](https://github.com/medfreeman/nuxt-netlify-cms-module/commit/78bda84))


### BREAKING CHANGES

* **package:** Move `netlify-cms` from dependencies to devDependencies and peerDependencies
Update readme



<a name="0.1.4"></a>
## [0.1.4](https://github.com/medfreeman/nuxt-netlify-cms-module/compare/v0.1.3...v0.1.4) (2017-09-04)


### Bug Fixes

* **README:** add missing module require instructions ([3192aae](https://github.com/medfreeman/nuxt-netlify-cms-module/commit/3192aae))



<a name="0.1.3"></a>
## [0.1.3](https://github.com/medfreeman/nuxt-netlify-cms-module/compare/v0.1.2...v0.1.3) (2017-09-04)


### Bug Fixes

* **core:** transpile utils to allow module to work ([141c677](https://github.com/medfreeman/nuxt-netlify-cms-module/commit/141c677))



<a name="0.1.2"></a>
## [0.1.2](https://github.com/medfreeman/nuxt-netlify-cms-module/compare/v0.1.1...v0.1.2) (2017-09-04)



<a name="0.1.1"></a>
## [0.1.1](https://github.com/medfreeman/nuxt-netlify-cms-module/compare/0.1.0...0.1.1) (2017-09-04)


### Bug Fixes

* **core:** transpile webpack config to allow module to work ([afdd102](https://github.com/medfreeman/nuxt-netlify-cms-module/commit/afdd102))



# 0.1.0 - 2017-08-02

- Initial release
