"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

/* eslint-disable import/no-extraneous-dependencies */
/* covered by nuxt */


var _path = require("path");

var _lodash = require("lodash");

var _lodash2 = _interopRequireDefault(_lodash);

var _cmsConfig = require("./utils/cms.config.file");

var _cmsConfig2 = _interopRequireDefault(_cmsConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var NUXT_CONFIG_KEY = "netlifyCms";
var NUXT_DIST_DIR = "dist";
var CMS_CONFIG_KEY = "cmsConfig";
var CMS_CONFIG_DIR = "netlify-cms";
var CMS_CONFIG_FILENAME = "config.yml";

// Defaults
var DEFAULTS = {
  adminPath: "admin",
  adminTitle: "Content Manager",
  cmsConfig: {
    media_folder: "static/uploads"
  }
};

var ConfigManager = function () {
  function ConfigManager(nuxtOptions, moduleOptions) {
    _classCallCheck(this, ConfigManager);

    this._relativeSrcDir = (0, _path.relative)(nuxtOptions.rootDir, nuxtOptions.srcDir);

    this._userOptions = Object.assign({}, nuxtOptions[NUXT_CONFIG_KEY], moduleOptions);

    var options = _lodash2.default.omit(Object.assign({}, DEFAULTS, this._userOptions), CMS_CONFIG_KEY);
    options.adminPath = options.adminPath.replace(/\/?$/, "/");
    options.buildDir = (0, _path.join)(nuxtOptions.buildDir, NUXT_DIST_DIR, options.adminPath);
    options.moduleConfigDir = (0, _path.join)(nuxtOptions.srcDir, CMS_CONFIG_DIR);
    this._config = Object.freeze(options);

    this._cmsConfigFile = new _cmsConfig2.default((0, _path.join)(this._config.moduleConfigDir, CMS_CONFIG_FILENAME));
  }

  _createClass(ConfigManager, [{
    key: "readCmsConfigFile",
    value: function readCmsConfigFile() {
      return this._cmsConfigFile.readFile();
    }
  }, {
    key: "config",
    get: function get() {
      return this._config;
    }
  }, {
    key: "cmsConfig",
    get: function get() {
      var config = this.constructor.setConfigPaths(Object.assign({}, DEFAULTS[CMS_CONFIG_KEY], this._cmsConfigFile.config, this._userOptions[CMS_CONFIG_KEY]), this._relativeSrcDir);
      return config;
    }
  }, {
    key: "cmsConfigFileName",
    get: function get() {
      return this._cmsConfigFile.fileName;
    }
  }], [{
    key: "setConfigPaths",
    value: function setConfigPaths(configObject, enforcedPath) {
      var newConfig = {
        collections: []
      };

      newConfig.media_folder = (0, _path.join)(enforcedPath, configObject.media_folder);

      if (configObject.collections) {
        configObject.collections.forEach(function (collection) {
          if (collection.folder) {
            newConfig.collections.push(Object.assign({}, collection, {
              folder: (0, _path.join)(enforcedPath, collection.folder)
            }));
          } else if (collection.files) {
            var collectionFiles = [];
            collection.files.forEach(function (fileEntry) {
              fileEntry.file && collectionFiles.push(Object.assign({}, fileEntry, {
                file: (0, _path.join)(enforcedPath, fileEntry.file)
              }));
            });
            newConfig.collections.push(Object.assign({}, collection, {
              files: collectionFiles
            }));
          }
        });
      }

      return Object.assign({}, configObject, newConfig);
    }
  }]);

  return ConfigManager;
}();

exports.default = ConfigManager;