"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.meta = undefined;
exports.default = NetlifyCmsModule;

var _lodash = require("lodash");

var _lodash2 = _interopRequireDefault(_lodash);

var _nuxt = require("nuxt");

var _chokidar = require("chokidar");

var _chokidar2 = _interopRequireDefault(_chokidar);

var _pify = require("pify");

var _pify2 = _interopRequireDefault(_pify);

var _webpack = require("webpack");

var _webpack2 = _interopRequireDefault(_webpack);

var _webpackDevMiddleware = require("webpack-dev-middleware");

var _webpackDevMiddleware2 = _interopRequireDefault(_webpackDevMiddleware);

var _webpackHotMiddleware = require("webpack-hot-middleware");

var _webpackHotMiddleware2 = _interopRequireDefault(_webpackHotMiddleware);

var _serveStatic = require("serve-static");

var _serveStatic2 = _interopRequireDefault(_serveStatic);

var _debug = require("debug");

var _debug2 = _interopRequireDefault(_debug);

var _package = require("../package.json");

var _package2 = _interopRequireDefault(_package);

var _configManager = require("./configManager");

var _configManager2 = _interopRequireDefault(_configManager);

var _webpack3 = require("./webpack.config");

var _webpack4 = _interopRequireDefault(_webpack3);

var _yaml = require("./utils/yaml");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; } /* eslint-disable import/no-extraneous-dependencies */
/* covered by nuxt */


var debug = (0, _debug2.default)("nuxt:netlify-cms");

var WEBPACK_CLIENT_COMPILER_NAME = "client";
var WEBPACK_NETLIFY_COMPILER_NAME = "netlify-cms";
var NETLIFY_CONFIG_FILE_NAME = "config.yml";

function NetlifyCmsModule(moduleOptions) {
  var _this = this;

  var configManager = new _configManager2.default(this.options, moduleOptions);
  var config = configManager.config;

  // This will be called once when builder started
  this.nuxt.plugin("build", function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(builder) {
      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              // This will be run just before webpack compiler starts
              builder.plugin("compile", function (_ref2) {
                var builder = _ref2.builder,
                    compiler = _ref2.compiler;

                var webpackConfig = (0, _webpack4.default)(WEBPACK_NETLIFY_COMPILER_NAME, _this.options, config);

                webpackConfig.plugins.push({
                  apply: function apply(compiler) {
                    compiler.plugin("emit", function (compilation, cb) {
                      var netlifyConfigYAML = (0, _yaml.toYAML)(configManager.cmsConfig);
                      compilation.assets[NETLIFY_CONFIG_FILE_NAME] = {
                        source: function source() {
                          return netlifyConfigYAML;
                        },
                        size: function size() {
                          return netlifyConfigYAML.length;
                        }
                      };
                      cb();
                    });
                  }
                });

                var netlifyCompiler = (0, _webpack2.default)(webpackConfig);

                // Only add the compiler in production,
                // in dev watch will be started by dev-middleware
                if (!_this.options.dev) {
                  compiler.compilers.push(netlifyCompiler);
                  compiler[netlifyCompiler.name] = netlifyCompiler;
                }

                // Use shared filesystem and cache
                var clientCompiler = compiler[WEBPACK_CLIENT_COMPILER_NAME];
                netlifyCompiler.outputFileSystem = clientCompiler.outputFileSystem;
                netlifyCompiler.cache = clientCompiler.cache;

                // This will be run just after webpack compiler ends
                netlifyCompiler.plugin("done", function () {
                  var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(stats) {
                    return regeneratorRuntime.wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            if (!stats.hasErrors()) {
                              _context.next = 2;
                              break;
                            }

                            return _context.abrupt("return");

                          case 2:
                            debug("Bundle built!");

                          case 3:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee, _this);
                  }));

                  return function (_x2) {
                    return _ref3.apply(this, arguments);
                  };
                }());

                // in development
                if (_this.options.dev) {
                  // Show a message inside console when the build is ready
                  builder.plugin("compiled", _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
                    return regeneratorRuntime.wrap(function _callee2$(_context2) {
                      while (1) {
                        switch (_context2.prev = _context2.next) {
                          case 0:
                            debug("Serving on: " + config.adminPath);

                          case 1:
                          case "end":
                            return _context2.stop();
                        }
                      }
                    }, _callee2, _this);
                  })));

                  // Create webpack dev middleware
                  var netlifyWebpackDevMiddleware = (0, _pify2.default)((0, _webpackDevMiddleware2.default)(netlifyCompiler, {
                    publicPath: "/",
                    stats: builder.webpackStats,
                    noInfo: true,
                    quiet: true,
                    watchOptions: _this.options.watchers.webpack
                  }));

                  // Create webpack hot middleware
                  var netlifyWebpackHotMiddleware = (0, _pify2.default)((0, _webpackHotMiddleware2.default)(netlifyCompiler, {
                    log: false,
                    heartbeat: 1000
                  }));

                  // Inject to renderer instance
                  if (builder.nuxt.renderer) {
                    builder.nuxt.renderer.netlifyWebpackDevMiddleware = netlifyWebpackDevMiddleware;
                    builder.nuxt.renderer.netlifyWebpackHotMiddleware = netlifyWebpackHotMiddleware;
                  }

                  // Stop webpack middleware on nuxt.close()
                  _this.nuxt.plugin("close", _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
                    return regeneratorRuntime.wrap(function _callee3$(_context3) {
                      while (1) {
                        switch (_context3.prev = _context3.next) {
                          case 0:
                            _context3.next = 2;
                            return _this.nuxt.renderer.netlifyWebpackDevMiddleware.close();

                          case 2:
                          case "end":
                            return _context3.stop();
                        }
                      }
                    }, _callee3, _this);
                  })));
                }
              });

            case 1:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4, _this);
    }));

    return function (_x) {
      return _ref.apply(this, arguments);
    };
  }());

  // Serve netlify CMS
  if (this.options.dev) {
    // Insert webpackDevMiddleware to serve netlify CMS in development
    this.addServerMiddleware({
      path: config.adminPath,
      handler: function () {
        var _ref6 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(req, res) {
          return regeneratorRuntime.wrap(function _callee5$(_context5) {
            while (1) {
              switch (_context5.prev = _context5.next) {
                case 0:
                  if (!_this.nuxt.renderer.netlifyWebpackDevMiddleware) {
                    _context5.next = 4;
                    break;
                  }

                  debug("requesting url: " + _nuxt.Utils.urlJoin(config.adminPath, req.url));
                  _context5.next = 4;
                  return _this.nuxt.renderer.netlifyWebpackDevMiddleware(req, res);

                case 4:
                  if (!_this.nuxt.renderer.netlifyWebpackHotMiddleware) {
                    _context5.next = 7;
                    break;
                  }

                  _context5.next = 7;
                  return _this.nuxt.renderer.netlifyWebpackHotMiddleware(req, res);

                case 7:
                case "end":
                  return _context5.stop();
              }
            }
          }, _callee5, _this);
        }));

        function handler(_x3, _x4) {
          return _ref6.apply(this, arguments);
        }

        return handler;
      }()
    });

    // Start watching config file
    var patterns = [_nuxt.Utils.r(configManager.cmsConfigFileName)];

    var options = Object.assign({}, this.options.watchers.chokidar, {
      ignoreInitial: true
    });

    var refreshFiles = _lodash2.default.debounce(function () {
      configManager.readCmsConfigFile();
      _this.nuxt.renderer.netlifyWebpackDevMiddleware.invalidate();
      _this.nuxt.renderer.netlifyWebpackHotMiddleware.publish({
        action: "reload"
      });
    }, 200);

    // Watch for src Files
    var fileWatcher = _chokidar2.default.watch(patterns, options).on("add", refreshFiles).on("change", refreshFiles).on("unlink", refreshFiles);

    this.nuxt.renderer.netlifyFileWatcher = fileWatcher;

    // Stop watching on nuxt.close()
    this.nuxt.plugin("close", function () {
      _this.nuxt.renderer.netlifyFileWatcher.close();
    });
  } else {
    // Statically serve netlify CMS (i.e. .nuxt/dist/admin/) files in production
    this.addServerMiddleware({
      path: config.adminPath,
      handler: (0, _serveStatic2.default)(config.buildDir, {
        maxAge: "1y" // 1 year in production
      })
    });
  }
}

// REQUIRED if publishing as an NPM package
exports.meta = _package2.default;